package com.zsc.edu.gateway.modules.iot.device.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import jakarta.validation.constraints.NotBlank;

/**
 * @author 15864
 */
@Data
@EqualsAndHashCode(callSuper = false)
@AllArgsConstructor
@NoArgsConstructor
public class DeviceDto {
    /**
     * 设备名称
     */
    @NotBlank(message = "设备名不能为空")
    private String name;

    /**
     * 硬件版本
     */
    private String hardwareVersion;

    /**
     * 固件版本
     */
    private String firmwareVersion;

    /**
     * 扩展属性
     */

    private String extendParams;

    /**
     * 设备物模型属性
     */
    private String properties;

    /**
     * 所属产品
     */
    private Long productId;

}
