package com.zsc.edu.gateway.modules.notice.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zsc.edu.gateway.framework.security.UserDetailsImpl;
import com.zsc.edu.gateway.modules.notice.dto.UserMessageDto;
import com.zsc.edu.gateway.modules.notice.entity.UserMessage;
import com.zsc.edu.gateway.modules.notice.query.AdminMessageQuery;
import com.zsc.edu.gateway.modules.notice.query.UserMessageQuery;
import com.zsc.edu.gateway.modules.notice.vo.AdminMessageVo;
import com.zsc.edu.gateway.modules.notice.vo.UserMessageVo;

import java.util.List;

/**
 * 用户消息Service
 *
 * @author harry_yao
 */
public interface UserMessageService extends IService<UserMessage> {

    Boolean createByAdmin(UserMessageDto dto);

    UserMessageVo detail(Long messageId, Long userId);

    IPage<UserMessageVo> page(Page<UserMessageVo> page, UserMessageQuery query);

    Integer countUnread(UserDetailsImpl userDetails);

    boolean markAsRead(UserDetailsImpl userDetails, List<Long> messageIds);


    boolean markAllAsRead(UserDetailsImpl userDetails);

    IPage<AdminMessageVo> getAdminMessagePage(Page<UserMessageVo> page, AdminMessageQuery query);
}
