package com.zsc.edu.gateway.modules.notice.vo;

import com.zsc.edu.gateway.modules.notice.entity.MessageType;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @author zhuang
 */
@Data
public class UserMessageVo {
    /**
     * 用户消息id
     */
    private Long messageId;
    /**
     * 是否已读
     */
    public Boolean isRead;
    /**
     * 阅读时间
     */
    public LocalDateTime readTime;

    /**
     * 用户名
     */
    public String username;

    /**
     * 消息类型
     */
    public MessageType type = MessageType.other;
    /**
     * 是否系统消息
     */
    public Boolean system;
    /**
     * 是否邮件
     */
    public Boolean email;
    /**
     * 是否短信
     */
    public Boolean sms;
    /**
     * 是否html
     */
    public Boolean html;
    /**
     * 标题
     */
    public String title;
    /**
     * 内容
     */
    public String content;
    /**
     * 备注
     */
    private String remark;
    /**
     * 创建时间
     */
    private LocalDateTime createTime;
    /**
     * 创建人
     */
    private String createBy;
    /**
     * 更新时间
     */
    private LocalDateTime updateTime;
    /**
     * 更新人
     */
    private String updateBy;

}
