package com.zsc.edu.gateway.domain;

import com.zsc.edu.gateway.modules.iot.tsl.entity.DataType;
import com.zsc.edu.gateway.modules.iot.tsl.entity.Param;

public class ParamBuilder extends BaseParamBuilder {
    public DataType dataType;
    public String uint;
    public Param.Type type;
    public Param.ForeignType foreignType;

    public static ParamBuilder aParam() {
        return new ParamBuilder();
    }

    public ParamBuilder dataType(DataType dataType) {
        this.dataType = dataType;
        return this;
    }

    public ParamBuilder uint(String uint) {
        this.uint = uint;
        return this;
    }

    public ParamBuilder type(Param.Type type) {
        this.type = type;
        return this;
    }

    public ParamBuilder foreignType(Param.ForeignType foreignType) {
        this.foreignType = foreignType;
        return this;
    }

    public Param build() {
        Param param = new Param();
        param.setUint(uint);
        param.setType(type);
        param.setForeignType(foreignType);
        param.setDataType(dataType);
        return param;
    }
}
